from funsSegm import CreateDataInst
import weka.core.DenseInstance as DenseInstance
import java.awt.Color as Color

def classify(img, MuClass):
    ip = img.getProcessor() #.convertToFloat() # as a copy  
    piximgTst = ip.getPixels()
    redTst = ip.toFloat(0, None)  
    Rtst = redTst.getPixels()
    greenTst = ip.toFloat(1, None)  
    Gtst = greenTst.getPixels()
    blueTst = ip.toFloat(2, None)  
    Btst = blueTst.getPixels()
    Lpiximg= len(piximgTst)
    isTestingSet = CreateDataInst()
    testD = DenseInstance(4)
    for i in range(len(piximgTst)):
        hsb = Color.RGBtoHSB(int(Rtst[i]),int(Gtst[i]),int(Btst[i]),None)
        testD.setValue(0,hsb[0])   # R
        testD.setValue(1,hsb[1])     # G
        testD.setValue(2,hsb[2])     # B
        isTestingSet.add(testD)
        #print i
    pixelsSegm = [0]*len(Rtst)
    labelProb = [0]*len(Rtst)
    print isTestingSet.numInstances()
    print isTestingSet.numAttributes()
    for k in range(isTestingSet.numInstances()):
        pixelsSegm[k] = MuClass.classifyInstance(isTestingSet.instance(k)) 
        labelProb[k] = MuClass.distributionForInstance(isTestingSet.instance(k))
    del isTestingSet
        
    return pixelsSegm, labelProb
